/* 
 * Copyright (C) 2003-2005 Petr Kozelka, PPK at seznam dot cz
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "../client/DCPlusPlus.h"
#include "Resource.h"
#include "UserInfo.h"

UserInfo::UserInfo(const User::Ptr& u) : UserInfoBase(u), op(false) { 
	update();
};

const tstring& UserInfo::getText(int col) const {
	return columns[col];
}

int UserInfo::compareItems(const UserInfo* a, const UserInfo* b, int col) {
	if(a == NULL || b == NULL){
		dcdebug("UserInfo::compareItems NULL >:-[\n");
		return NULL;
	}
	if(col == COLUMN_NICK) {
		if(a->getOp() && !b->getOp()) {
			return -1;
		} else if(!a->getOp() && b->getOp()) {
			return 1;
		}
	}
	if(col == COLUMN_SHARED || col == COLUMN_EXACT_SHARED) {
		return compare(a->user->getBytesShared(), b->user->getBytesShared());
	}
	return lstrcmpi(a->columns[col].c_str(), b->columns[col].c_str());
}

void UserInfo::update() { 
	columns[COLUMN_NICK] = Text::toT(user->getNick());
	columns[COLUMN_SHARED] = Text::toT(Util::formatBytes(user->getBytesShared()));
	columns[COLUMN_EXACT_SHARED] = Text::toT(Util::formatExactSize(user->getBytesShared()));
	columns[COLUMN_DESCRIPTION] = Text::toT(user->getDescription());
	columns[COLUMN_TAG] = Text::toT(user->getTag());
	columns[COLUMN_CONNECTION] = Text::toT(user->getConnection());
	columns[COLUMN_EMAIL] = Text::toT(user->getEmail());
	columns[COLUMN_CLIENTID] = Text::toT(user->getClientID());
	columns[COLUMN_VERSION] = Text::toT(user->getVersion());
	columns[COLUMN_MODE] = Text::toT(user->getMode());
	columns[COLUMN_HUBS] = Text::toT(user->getHubs());
	columns[COLUMN_SLOTS] = Text::toT(user->getSlots());
	columns[COLUMN_LIMITER] = Text::toT(user->getUpload());
	columns[COLUMN_IP] = Text::toT(user->getIp());
	op = user->isSet(User::OP); 
}